import { P as Preset, I as Import, B as BuiltinPresetName, U as UnimportOptions } from './types-e15aa7ca';
export { B as BuiltinPresetName, I as Import, a as ImportName, M as ModuleId, P as Preset, c as PresetImport, U as UnimportOptions, b as builtinPresets } from './types-e15aa7ca';
import * as MagicString from 'magic-string';
import MagicString__default from 'magic-string';

declare function resolvePreset(preset: Preset): Import[];
declare function resolveBuiltinPresets(presets: (BuiltinPresetName | Preset)[]): Import[];

declare const excludeRE: RegExp[];
declare const importAsRE: RegExp;
declare const separatorRE: RegExp;
declare function defineUnimportPreset(preset: Preset): Preset;
declare function stripCommentsAndStrings(code: string): string;
declare function toImports(imports: Import[], isCJS?: boolean): string;
declare function dedupeImports(imports: Import[], warn: (msg: string) => void): Import[];
declare function toExports(imports: Import[]): string;
declare function toTypeDeclrationItems(imports: Import[]): string[];
declare function toTypeDeclrationFile(imports: Import[]): string;
declare function addImportToCode(code: string, imports: Import[], isCJS?: boolean, mergeExisting?: boolean): {
    s: MagicString__default;
    code: string;
};

declare type Unimport = ReturnType<typeof createUnimport>;
declare function createUnimport(opts: Partial<UnimportOptions>): {
    detectImports: (code: string) => {
        strippedCode: string;
        isCJSContext: boolean;
        matchedImports: Import[];
    };
    addImports: (code: string, mergeExisting?: boolean) => {
        s: MagicString.default;
        code: string;
    };
    generateTypeDecarations: () => string;
};

export { Unimport, addImportToCode, createUnimport, dedupeImports, defineUnimportPreset, excludeRE, importAsRE, resolveBuiltinPresets, resolvePreset, separatorRE, stripCommentsAndStrings, toExports, toImports, toTypeDeclrationFile, toTypeDeclrationItems };
